//<c>   Copyright 1996-2000 by Gerry J. Danen; all rights reserved.

//<t>   Save ANSI colours in a batch file

//      Usage: ANSCOL >file.bat

//      1. get colour under cursor
//      2. write batch file that will echo the proper colour codes
// todo 3. destination: %tmp% or %temp%, or 1st directory in path


#include"gd_tools.h"
#include"gd_ansi.h"


COL BIOS2ANSI_color( COL c, BOOL isFG, int *hilite )
{
    int adder = 10 ;

    if ( c > 7 )
    {
        *hilite = 1 ;
        c = c - 8 ;
    }
    else
        *hilite = 0 ;

    if ( isFG )
        adder = 0 ;

    switch ( c )
    {
        case BLACK :
            return( ANSI_FG_BLACK   + adder );
        case BLUE :
            return( ANSI_FG_BLUE    + adder );
        case GREEN :
            return( ANSI_FG_GREEN   + adder );
        case CYAN :
            return( ANSI_FG_CYAN    + adder );
        case RED :
            return( ANSI_FG_RED     + adder );
        case MAGENTA :
            return( ANSI_FG_MAGENTA + adder );
        case BROWN :
            return( ANSI_FG_BROWN   + adder );
        case WHITE :
            return( ANSI_FG_WHITE   + adder );
    }
    return( 0 );
}


void    main( int argc, char *argv[] )
{
    COL         fg, bg ;
    int         hi = 0, f, b ;

    ScRead( &fg, &bg );

    b = BIOS2ANSI_color( bg, NO , &hi );
    f = BIOS2ANSI_color( fg, YES, &hi );

    printf( "@echo off\n\n echo %c[%d;%d;%dm\n\n", 27, hi, f, b );
    printf( " rem  This batch file was created by ANSCOL, a program to capture screen\n"
            " rem  colours and allow them to be reset from a batch file.\n\n"
            " rem  ANSCOL is Copyright (c) 1996-2000 by Gerry J Danen, Edmonton AB Canada\n"
            " rem  gdanen@bigfoot.com\n\n" );
}
